/* sine function and its partial derivatives */
double fsine(double time, vec& d) {
    return d(0) * sin(2*M_PI*d(3)*time + d(1)) + d(2);
}

double fsine_diff_ampl(double time, vec& d) {
    return sin(2*M_PI*d(3)*time + d(1));
}

double fsine_diff_phase(double time, vec& d) {
    return d(0) * cos(2*M_PI*d(3)*time + d(1));
}

double fsine_diff_freq(double time, vec& d) {
    double aux = 2*M_PI*time;
    return d(0)*aux*cos(aux*d(3) + d(1));
}
