#! /usr/bin/env lua

require('article')

local n_rep   = 30
local n_freqs = 30
local n_cols  = 6

local r_col = {}
for i = 1, n_cols do
    r_col[i] = {}
    
    for f = 1, n_freqs do
        r_col[i][f] = {}
    end
end

local function read_results(r)
    local o = assert( io.open('out/' .. r, 'r') )

    for f = 1, n_freqs do
        for c = 1, n_cols do
            r_col[c][f][r] = o:read('*n')
        end
    end
    
    o:close()
end

local function output_std(c)
    local o = assert( io.open('out/col' .. c, 'w') )
    
    for f = 1, n_freqs do
        local m, d = std(r_col[c][f])
        o:write( string.format('%f %f %f\n', r_col[1][f][1], m, d) )
    end
    
    o:close()
end

ex('make')
ex('mkdir -p out')

for r = 1, n_rep do
    pex('./lm   %d > out/%d'  , r, r)
end

for r = 1, n_rep do
    read_results(r)
end

for c = 2, n_cols do
    output_std(c)
end
